VERSION 5.00
Object = "{EAB22AC0-30C1-11CF-A7EB-0000C05BAE0B}#1.1#0"; "ieframe.dll"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Image GPS"
   ClientHeight    =   8415
   ClientLeft      =   1530
   ClientTop       =   3030
   ClientWidth     =   13425
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   8415
   ScaleWidth      =   13425
   Begin VB.CommandButton CmdSearch 
      Caption         =   "Buscar"
      Default         =   -1  'True
      Height          =   375
      Left            =   7800
      TabIndex        =   7
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox TxtSearch 
      Height          =   360
      Left            =   3480
      TabIndex        =   6
      Top             =   120
      Width           =   4215
   End
   Begin VB.CommandButton CmdSave 
      Caption         =   "Guardar Posicin"
      Enabled         =   0   'False
      Height          =   375
      Left            =   11400
      TabIndex        =   5
      Top             =   7920
      Width           =   1935
   End
   Begin VB.DriveListBox Drive1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3255
   End
   Begin VB.FileListBox File1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2625
      Left            =   120
      Pattern         =   "*.jp*g"
      TabIndex        =   2
      Top             =   3360
      Width           =   3255
   End
   Begin VB.DirListBox Dir1 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2790
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   3255
   End
   Begin SHDocVwCtl.WebBrowser WebBrowser1 
      Height          =   7215
      Left            =   3480
      TabIndex        =   0
      Top             =   600
      Width           =   9855
      ExtentX         =   17383
      ExtentY         =   12726
      ViewMode        =   0
      Offline         =   0
      Silent          =   0
      RegisterAsBrowser=   0
      RegisterAsDropTarget=   1
      AutoArrange     =   0   'False
      NoClientEdge    =   0   'False
      AlignLeft       =   0   'False
      NoWebView       =   0   'False
      HideFileNames   =   0   'False
      SingleClick     =   0   'False
      SingleSelection =   0   'False
      NoFolders       =   0   'False
      Transparent     =   0   'False
      ViewID          =   "{0057D0E0-3573-11CF-AE69-08002B2E1262}"
      Location        =   "http:///"
   End
   Begin VB.Label Label1 
      BackColor       =   &H80000018&
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   3480
      TabIndex        =   4
      Top             =   7920
      Width           =   7815
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   2175
      Left            =   120
      Stretch         =   -1  'True
      Top             =   6120
      Width           =   3255
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'------------------------------
'Autor: Leandro Ascierto
'Web: www.leandroascierto.com
'Date: 28/02/2013
'------------------------------
Private m_Lat As Double
Private m_Lng As Double

Private Sub CmdSave_Click()
    If MsgBox("Desea sobrescrivir la imagen actual?", vbOKCancel) = vbOK Then
        If WriteImageGPS(File1.Path & "\" & File1.FileName, m_Lat, m_Lng) Then
            MsgBox "La imgen se guardo correctamente."
        Else
            MsgBox "Ha ocurrido un error al intentar guardar la imgen"
        End If
    End If
End Sub

Private Sub CmdSearch_Click()
    Dim Lat As Double, Lng As Double
    Call GetGoogleMapsGeocode(TxtSearch.Text, Lat, Lng)
    Label1.Caption = "Latitud: " & Lat & "   Longitud: " & Lng
    Call WebBrowser1.Document.parentWindow.show_position(Replace(Lat, ",", "."), Replace(Lng, ",", "."))
    m_Lat = Lat
    m_Lng = Lng
End Sub

Private Sub Form_Load()
    WebBrowser1.Navigate App.Path & "\mapa.html"
End Sub

Private Sub Dir1_Change()
    File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()
    Dir1.Path = Drive1.Drive
End Sub

Private Sub File1_Click()
    Dim Lat As Double, Lng As Double
    
    On Error Resume Next
    CmdSave.Enabled = False
    Image1.Picture = LoadPicture(File1.Path & "\" & File1.FileName)
    On Error GoTo 0
    
    If ReadImageGPS(File1.Path & "\" & File1.FileName, Lat, Lng) Then
        'WebBrowser1.Document.parentWindow.execScript "show_position(" & Replace(Lat, ",", ".") & "," & Replace(Lng, ",", ".") & ")"
        Call WebBrowser1.Document.parentWindow.show_position(Replace(Lat, ",", "."), Replace(Lng, ",", "."))
        Label1.Caption = "Latitud: " & Lat & "   Longitud: " & Lng
    Else
        Label1.Caption = "La imgen no tiene cordenadas GPS"
    End If

End Sub


Private Sub WebBrowser1_DocumentComplete(ByVal pDisp As Object, URL As Variant)
    Set WebBrowser1.Document.parentWindow.ObjParent = Me
End Sub

'Envento producido por javascript
Public Sub MapsMarkerEvent(Lat, Lng)
    Label1.Caption = "Latitud: " & Lat & "   Longitud: " & Lng
    m_Lat = Lat
    m_Lng = Lng

    If File1.ListIndex > -1 Then
        CmdSave.Enabled = True
    End If
End Sub


'http://stackoverflow.com/questions/4158492/code-to-get-gps-coordinates-from-address-vb6-vba-vbscript
Function GetGoogleMapsGeocode(sAddr As String, ByRef Latitude As Double, ByRef Longitude As Double) As Boolean

    Dim xhrRequest As Object ' XMLHTTP60
    Dim sQuery As String
    Dim domResponse As Object 'DOMDocument60
    Dim ixnStatus As Object 'IXMLDOMNode
    Dim ixnLat As Object 'IXMLDOMNode
    Dim ixnLng As Object 'IXMLDOMNode
    
    
    ' Use the empty string to indicate failure
    
    Set xhrRequest = CreateObject("Msxml2.XMLHTTP") 'New XMLHTTP60
    sQuery = "http://maps.googleapis.com/maps/api/geocode/xml?sensor=false&address="
    sQuery = sQuery & Replace(sAddr, " ", "+")
    xhrRequest.Open "GET", sQuery, False
    xhrRequest.send
    
    Set domResponse = CreateObject("Msxml2.DOMDocument") 'New DOMDocument60
    domResponse.loadXML xhrRequest.responseText
    Set ixnStatus = domResponse.selectSingleNode("//status")
    
    If (ixnStatus.Text <> "OK") Then
        Exit Function
    End If
    
    Set ixnLat = domResponse.selectSingleNode("/GeocodeResponse/result/geometry/location/lat")
    Set ixnLng = domResponse.selectSingleNode("/GeocodeResponse/result/geometry/location/lng")
    
    Latitude = Val(ixnLat.Text)
    Longitude = Val(ixnLng.Text)
    GetGoogleMapsGeocode = True

End Function
